// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_mapem_ts_msgs:msg/NodeAttributeSetXY.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__NODE_ATTRIBUTE_SET_XY__STRUCT_H_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__NODE_ATTRIBUTE_SET_XY__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'local_node'
#include "etsi_its_mapem_ts_msgs/msg/detail/node_attribute_xy_list__struct.h"
// Member 'disabled'
// Member 'enabled'
#include "etsi_its_mapem_ts_msgs/msg/detail/segment_attribute_xy_list__struct.h"
// Member 'data'
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_data_attribute_list__struct.h"
// Member 'd_width'
// Member 'd_elevation'
#include "etsi_its_mapem_ts_msgs/msg/detail/offset_b10__struct.h"

/// Struct defined in msg/NodeAttributeSetXY in the package etsi_its_mapem_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_mapem_ts_msgs__msg__NodeAttributeSetXY
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/is_ts103301/MAPEM-PDU-Descriptions.asn
  ///   asn1/raw/is_ts103301/cdd/ITS-Container.asn
  ///   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
  ///   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
  ///   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
  ///   -t
  ///   mapem_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_mapem_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// NodeAttributeSetXY ::= SEQUENCE {
  ///   localNode    NodeAttributeXYList OPTIONAL,
  ///   disabled     SegmentAttributeXYList OPTIONAL,
  ///   enabled      SegmentAttributeXYList OPTIONAL,
  ///   data         LaneDataAttributeList OPTIONAL,
  ///   dWidth       Offset-B10 OPTIONAL,
  ///   dElevation   Offset-B10 OPTIONAL,
  ///   regional     SEQUENCE (SIZE(1..4)) OF
  ///                RegionalExtension {{Reg-NodeAttributeSetXY}} OPTIONAL,
  /// ------------------------------------------------------------------------------
  etsi_its_mapem_ts_msgs__msg__NodeAttributeXYList local_node;
  bool local_node_is_present;
  etsi_its_mapem_ts_msgs__msg__SegmentAttributeXYList disabled;
  bool disabled_is_present;
  etsi_its_mapem_ts_msgs__msg__SegmentAttributeXYList enabled;
  bool enabled_is_present;
  etsi_its_mapem_ts_msgs__msg__LaneDataAttributeList data;
  bool data_is_present;
  etsi_its_mapem_ts_msgs__msg__OffsetB10 d_width;
  bool d_width_is_present;
  etsi_its_mapem_ts_msgs__msg__OffsetB10 d_elevation;
  bool d_elevation_is_present;
} etsi_its_mapem_ts_msgs__msg__NodeAttributeSetXY;

// Struct for a sequence of etsi_its_mapem_ts_msgs__msg__NodeAttributeSetXY.
typedef struct etsi_its_mapem_ts_msgs__msg__NodeAttributeSetXY__Sequence
{
  etsi_its_mapem_ts_msgs__msg__NodeAttributeSetXY * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_mapem_ts_msgs__msg__NodeAttributeSetXY__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__NODE_ATTRIBUTE_SET_XY__STRUCT_H_
