// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mapem_ts_msgs:msg/NodeAttributeXY.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__NODE_ATTRIBUTE_XY__STRUCT_HPP_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__NODE_ATTRIBUTE_XY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__NodeAttributeXY __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__NodeAttributeXY __declspec(deprecated)
#endif

namespace etsi_its_mapem_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct NodeAttributeXY_
{
  using Type = NodeAttributeXY_<ContainerAllocator>;

  explicit NodeAttributeXY_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  explicit NodeAttributeXY_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  // field types and members
  using _value_type =
    uint8_t;
  _value_type value;

  // setters for named parameter idiom
  Type & set__value(
    const uint8_t & _arg)
  {
    this->value = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t RESERVED =
    0u;
  static constexpr uint8_t STOP_LINE =
    1u;
  static constexpr uint8_t ROUNDED_CAP_STYLE_A =
    2u;
  static constexpr uint8_t ROUNDED_CAP_STYLE_B =
    3u;
  static constexpr uint8_t MERGE_POINT =
    4u;
  static constexpr uint8_t DIVERGE_POINT =
    5u;
  static constexpr uint8_t DOWNSTREAM_STOP_LINE =
    6u;
  static constexpr uint8_t DOWNSTREAM_START_NODE =
    7u;
  static constexpr uint8_t CLOSED_TO_TRAFFIC =
    8u;
  static constexpr uint8_t SAFE_ISLAND =
    9u;
  static constexpr uint8_t CURB_PRESENT_AT_STEP_OFF =
    10u;
  static constexpr uint8_t HYDRANT_PRESENT =
    11u;

  // pointer types
  using RawPtr =
    etsi_its_mapem_ts_msgs::msg::NodeAttributeXY_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mapem_ts_msgs::msg::NodeAttributeXY_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::NodeAttributeXY_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::NodeAttributeXY_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::NodeAttributeXY_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::NodeAttributeXY_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::NodeAttributeXY_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::NodeAttributeXY_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::NodeAttributeXY_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::NodeAttributeXY_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__NodeAttributeXY
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::NodeAttributeXY_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__NodeAttributeXY
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::NodeAttributeXY_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const NodeAttributeXY_ & other) const
  {
    if (this->value != other.value) {
      return false;
    }
    return true;
  }
  bool operator!=(const NodeAttributeXY_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct NodeAttributeXY_

// alias to use template instance with default allocator
using NodeAttributeXY =
  etsi_its_mapem_ts_msgs::msg::NodeAttributeXY_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t NodeAttributeXY_<ContainerAllocator>::RESERVED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t NodeAttributeXY_<ContainerAllocator>::STOP_LINE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t NodeAttributeXY_<ContainerAllocator>::ROUNDED_CAP_STYLE_A;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t NodeAttributeXY_<ContainerAllocator>::ROUNDED_CAP_STYLE_B;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t NodeAttributeXY_<ContainerAllocator>::MERGE_POINT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t NodeAttributeXY_<ContainerAllocator>::DIVERGE_POINT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t NodeAttributeXY_<ContainerAllocator>::DOWNSTREAM_STOP_LINE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t NodeAttributeXY_<ContainerAllocator>::DOWNSTREAM_START_NODE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t NodeAttributeXY_<ContainerAllocator>::CLOSED_TO_TRAFFIC;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t NodeAttributeXY_<ContainerAllocator>::SAFE_ISLAND;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t NodeAttributeXY_<ContainerAllocator>::CURB_PRESENT_AT_STEP_OFF;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t NodeAttributeXY_<ContainerAllocator>::HYDRANT_PRESENT;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_mapem_ts_msgs

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__NODE_ATTRIBUTE_XY__STRUCT_HPP_
