// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_mapem_ts_msgs:msg/RoadSegment.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__ROAD_SEGMENT__STRUCT_H_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__ROAD_SEGMENT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'name'
#include "etsi_its_mapem_ts_msgs/msg/detail/descriptive_name__struct.h"
// Member 'id'
#include "etsi_its_mapem_ts_msgs/msg/detail/road_segment_reference_id__struct.h"
// Member 'revision'
#include "etsi_its_mapem_ts_msgs/msg/detail/msg_count__struct.h"
// Member 'ref_point'
#include "etsi_its_mapem_ts_msgs/msg/detail/position3_d__struct.h"
// Member 'lane_width'
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_width__struct.h"
// Member 'speed_limits'
#include "etsi_its_mapem_ts_msgs/msg/detail/speed_limit_list__struct.h"
// Member 'road_lane_set'
#include "etsi_its_mapem_ts_msgs/msg/detail/road_lane_set_list__struct.h"

/// Struct defined in msg/RoadSegment in the package etsi_its_mapem_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_mapem_ts_msgs__msg__RoadSegment
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/is_ts103301/MAPEM-PDU-Descriptions.asn
  ///   asn1/raw/is_ts103301/cdd/ITS-Container.asn
  ///   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
  ///   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
  ///   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
  ///   -t
  ///   mapem_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_mapem_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// RoadSegment ::= SEQUENCE {
  ///   name        DescriptiveName OPTIONAL,
  ///   id          RoadSegmentReferenceID,
  ///   revision    MsgCount,
  ///   refPoint    Position3D,
  ///   laneWidth   LaneWidth OPTIONAL,
  ///   speedLimits SpeedLimitList OPTIONAL,
  ///   roadLaneSet RoadLaneSetList,
  ///   regional    SEQUENCE (SIZE(1..4)) OF
  ///               RegionalExtension {{Reg-RoadSegment}} OPTIONAL,
  /// ------------------------------------------------------------------------------
  etsi_its_mapem_ts_msgs__msg__DescriptiveName name;
  bool name_is_present;
  etsi_its_mapem_ts_msgs__msg__RoadSegmentReferenceID id;
  etsi_its_mapem_ts_msgs__msg__MsgCount revision;
  etsi_its_mapem_ts_msgs__msg__Position3D ref_point;
  etsi_its_mapem_ts_msgs__msg__LaneWidth lane_width;
  bool lane_width_is_present;
  etsi_its_mapem_ts_msgs__msg__SpeedLimitList speed_limits;
  bool speed_limits_is_present;
  etsi_its_mapem_ts_msgs__msg__RoadLaneSetList road_lane_set;
} etsi_its_mapem_ts_msgs__msg__RoadSegment;

// Struct for a sequence of etsi_its_mapem_ts_msgs__msg__RoadSegment.
typedef struct etsi_its_mapem_ts_msgs__msg__RoadSegment__Sequence
{
  etsi_its_mapem_ts_msgs__msg__RoadSegment * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_mapem_ts_msgs__msg__RoadSegment__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__ROAD_SEGMENT__STRUCT_H_
