// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_mapem_ts_msgs:msg/LaneDataAttribute.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__LANE_DATA_ATTRIBUTE__TRAITS_HPP_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__LANE_DATA_ATTRIBUTE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_mapem_ts_msgs/msg/detail/lane_data_attribute__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'path_end_point_angle'
#include "etsi_its_mapem_ts_msgs/msg/detail/delta_angle__traits.hpp"
// Member 'lane_crown_point_center'
// Member 'lane_crown_point_left'
// Member 'lane_crown_point_right'
#include "etsi_its_mapem_ts_msgs/msg/detail/roadway_crown_angle__traits.hpp"
// Member 'lane_angle'
#include "etsi_its_mapem_ts_msgs/msg/detail/merge_diverge_node_angle__traits.hpp"
// Member 'speed_limits'
#include "etsi_its_mapem_ts_msgs/msg/detail/speed_limit_list__traits.hpp"

namespace etsi_its_mapem_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const LaneDataAttribute & msg,
  std::ostream & out)
{
  out << "{";
  // member: choice
  {
    out << "choice: ";
    rosidl_generator_traits::value_to_yaml(msg.choice, out);
    out << ", ";
  }

  // member: path_end_point_angle
  {
    out << "path_end_point_angle: ";
    to_flow_style_yaml(msg.path_end_point_angle, out);
    out << ", ";
  }

  // member: lane_crown_point_center
  {
    out << "lane_crown_point_center: ";
    to_flow_style_yaml(msg.lane_crown_point_center, out);
    out << ", ";
  }

  // member: lane_crown_point_left
  {
    out << "lane_crown_point_left: ";
    to_flow_style_yaml(msg.lane_crown_point_left, out);
    out << ", ";
  }

  // member: lane_crown_point_right
  {
    out << "lane_crown_point_right: ";
    to_flow_style_yaml(msg.lane_crown_point_right, out);
    out << ", ";
  }

  // member: lane_angle
  {
    out << "lane_angle: ";
    to_flow_style_yaml(msg.lane_angle, out);
    out << ", ";
  }

  // member: speed_limits
  {
    out << "speed_limits: ";
    to_flow_style_yaml(msg.speed_limits, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const LaneDataAttribute & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: choice
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "choice: ";
    rosidl_generator_traits::value_to_yaml(msg.choice, out);
    out << "\n";
  }

  // member: path_end_point_angle
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "path_end_point_angle:\n";
    to_block_style_yaml(msg.path_end_point_angle, out, indentation + 2);
  }

  // member: lane_crown_point_center
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lane_crown_point_center:\n";
    to_block_style_yaml(msg.lane_crown_point_center, out, indentation + 2);
  }

  // member: lane_crown_point_left
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lane_crown_point_left:\n";
    to_block_style_yaml(msg.lane_crown_point_left, out, indentation + 2);
  }

  // member: lane_crown_point_right
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lane_crown_point_right:\n";
    to_block_style_yaml(msg.lane_crown_point_right, out, indentation + 2);
  }

  // member: lane_angle
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lane_angle:\n";
    to_block_style_yaml(msg.lane_angle, out, indentation + 2);
  }

  // member: speed_limits
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speed_limits:\n";
    to_block_style_yaml(msg.speed_limits, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const LaneDataAttribute & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_mapem_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_mapem_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_mapem_ts_msgs::msg::LaneDataAttribute & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_mapem_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_mapem_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_mapem_ts_msgs::msg::LaneDataAttribute & msg)
{
  return etsi_its_mapem_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_mapem_ts_msgs::msg::LaneDataAttribute>()
{
  return "etsi_its_mapem_ts_msgs::msg::LaneDataAttribute";
}

template<>
inline const char * name<etsi_its_mapem_ts_msgs::msg::LaneDataAttribute>()
{
  return "etsi_its_mapem_ts_msgs/msg/LaneDataAttribute";
}

template<>
struct has_fixed_size<etsi_its_mapem_ts_msgs::msg::LaneDataAttribute>
  : std::integral_constant<bool, has_fixed_size<etsi_its_mapem_ts_msgs::msg::DeltaAngle>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::MergeDivergeNodeAngle>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::RoadwayCrownAngle>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::SpeedLimitList>::value> {};

template<>
struct has_bounded_size<etsi_its_mapem_ts_msgs::msg::LaneDataAttribute>
  : std::integral_constant<bool, has_bounded_size<etsi_its_mapem_ts_msgs::msg::DeltaAngle>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::MergeDivergeNodeAngle>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::RoadwayCrownAngle>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::SpeedLimitList>::value> {};

template<>
struct is_message<etsi_its_mapem_ts_msgs::msg::LaneDataAttribute>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__LANE_DATA_ATTRIBUTE__TRAITS_HPP_
