// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_mapem_ts_msgs:msg/Position3D.idl
// generated code does not contain a copyright notice
#include "etsi_its_mapem_ts_msgs/msg/detail/position3_d__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `lat`
#include "etsi_its_mapem_ts_msgs/msg/detail/latitude__functions.h"
// Member `lon`
#include "etsi_its_mapem_ts_msgs/msg/detail/longitude__functions.h"
// Member `elevation`
#include "etsi_its_mapem_ts_msgs/msg/detail/elevation__functions.h"

bool
etsi_its_mapem_ts_msgs__msg__Position3D__init(etsi_its_mapem_ts_msgs__msg__Position3D * msg)
{
  if (!msg) {
    return false;
  }
  // lat
  if (!etsi_its_mapem_ts_msgs__msg__Latitude__init(&msg->lat)) {
    etsi_its_mapem_ts_msgs__msg__Position3D__fini(msg);
    return false;
  }
  // lon
  if (!etsi_its_mapem_ts_msgs__msg__Longitude__init(&msg->lon)) {
    etsi_its_mapem_ts_msgs__msg__Position3D__fini(msg);
    return false;
  }
  // elevation
  if (!etsi_its_mapem_ts_msgs__msg__Elevation__init(&msg->elevation)) {
    etsi_its_mapem_ts_msgs__msg__Position3D__fini(msg);
    return false;
  }
  // elevation_is_present
  return true;
}

void
etsi_its_mapem_ts_msgs__msg__Position3D__fini(etsi_its_mapem_ts_msgs__msg__Position3D * msg)
{
  if (!msg) {
    return;
  }
  // lat
  etsi_its_mapem_ts_msgs__msg__Latitude__fini(&msg->lat);
  // lon
  etsi_its_mapem_ts_msgs__msg__Longitude__fini(&msg->lon);
  // elevation
  etsi_its_mapem_ts_msgs__msg__Elevation__fini(&msg->elevation);
  // elevation_is_present
}

bool
etsi_its_mapem_ts_msgs__msg__Position3D__are_equal(const etsi_its_mapem_ts_msgs__msg__Position3D * lhs, const etsi_its_mapem_ts_msgs__msg__Position3D * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // lat
  if (!etsi_its_mapem_ts_msgs__msg__Latitude__are_equal(
      &(lhs->lat), &(rhs->lat)))
  {
    return false;
  }
  // lon
  if (!etsi_its_mapem_ts_msgs__msg__Longitude__are_equal(
      &(lhs->lon), &(rhs->lon)))
  {
    return false;
  }
  // elevation
  if (!etsi_its_mapem_ts_msgs__msg__Elevation__are_equal(
      &(lhs->elevation), &(rhs->elevation)))
  {
    return false;
  }
  // elevation_is_present
  if (lhs->elevation_is_present != rhs->elevation_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_mapem_ts_msgs__msg__Position3D__copy(
  const etsi_its_mapem_ts_msgs__msg__Position3D * input,
  etsi_its_mapem_ts_msgs__msg__Position3D * output)
{
  if (!input || !output) {
    return false;
  }
  // lat
  if (!etsi_its_mapem_ts_msgs__msg__Latitude__copy(
      &(input->lat), &(output->lat)))
  {
    return false;
  }
  // lon
  if (!etsi_its_mapem_ts_msgs__msg__Longitude__copy(
      &(input->lon), &(output->lon)))
  {
    return false;
  }
  // elevation
  if (!etsi_its_mapem_ts_msgs__msg__Elevation__copy(
      &(input->elevation), &(output->elevation)))
  {
    return false;
  }
  // elevation_is_present
  output->elevation_is_present = input->elevation_is_present;
  return true;
}

etsi_its_mapem_ts_msgs__msg__Position3D *
etsi_its_mapem_ts_msgs__msg__Position3D__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mapem_ts_msgs__msg__Position3D * msg = (etsi_its_mapem_ts_msgs__msg__Position3D *)allocator.allocate(sizeof(etsi_its_mapem_ts_msgs__msg__Position3D), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_mapem_ts_msgs__msg__Position3D));
  bool success = etsi_its_mapem_ts_msgs__msg__Position3D__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_mapem_ts_msgs__msg__Position3D__destroy(etsi_its_mapem_ts_msgs__msg__Position3D * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_mapem_ts_msgs__msg__Position3D__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_mapem_ts_msgs__msg__Position3D__Sequence__init(etsi_its_mapem_ts_msgs__msg__Position3D__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mapem_ts_msgs__msg__Position3D * data = NULL;

  if (size) {
    data = (etsi_its_mapem_ts_msgs__msg__Position3D *)allocator.zero_allocate(size, sizeof(etsi_its_mapem_ts_msgs__msg__Position3D), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_mapem_ts_msgs__msg__Position3D__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_mapem_ts_msgs__msg__Position3D__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_mapem_ts_msgs__msg__Position3D__Sequence__fini(etsi_its_mapem_ts_msgs__msg__Position3D__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_mapem_ts_msgs__msg__Position3D__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_mapem_ts_msgs__msg__Position3D__Sequence *
etsi_its_mapem_ts_msgs__msg__Position3D__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mapem_ts_msgs__msg__Position3D__Sequence * array = (etsi_its_mapem_ts_msgs__msg__Position3D__Sequence *)allocator.allocate(sizeof(etsi_its_mapem_ts_msgs__msg__Position3D__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_mapem_ts_msgs__msg__Position3D__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_mapem_ts_msgs__msg__Position3D__Sequence__destroy(etsi_its_mapem_ts_msgs__msg__Position3D__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_mapem_ts_msgs__msg__Position3D__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_mapem_ts_msgs__msg__Position3D__Sequence__are_equal(const etsi_its_mapem_ts_msgs__msg__Position3D__Sequence * lhs, const etsi_its_mapem_ts_msgs__msg__Position3D__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_mapem_ts_msgs__msg__Position3D__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_mapem_ts_msgs__msg__Position3D__Sequence__copy(
  const etsi_its_mapem_ts_msgs__msg__Position3D__Sequence * input,
  etsi_its_mapem_ts_msgs__msg__Position3D__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_mapem_ts_msgs__msg__Position3D);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_mapem_ts_msgs__msg__Position3D * data =
      (etsi_its_mapem_ts_msgs__msg__Position3D *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_mapem_ts_msgs__msg__Position3D__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_mapem_ts_msgs__msg__Position3D__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_mapem_ts_msgs__msg__Position3D__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
