// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mapem_ts_msgs:msg/RoadSegment.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__ROAD_SEGMENT__STRUCT_HPP_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__ROAD_SEGMENT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'name'
#include "etsi_its_mapem_ts_msgs/msg/detail/descriptive_name__struct.hpp"
// Member 'id'
#include "etsi_its_mapem_ts_msgs/msg/detail/road_segment_reference_id__struct.hpp"
// Member 'revision'
#include "etsi_its_mapem_ts_msgs/msg/detail/msg_count__struct.hpp"
// Member 'ref_point'
#include "etsi_its_mapem_ts_msgs/msg/detail/position3_d__struct.hpp"
// Member 'lane_width'
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_width__struct.hpp"
// Member 'speed_limits'
#include "etsi_its_mapem_ts_msgs/msg/detail/speed_limit_list__struct.hpp"
// Member 'road_lane_set'
#include "etsi_its_mapem_ts_msgs/msg/detail/road_lane_set_list__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__RoadSegment __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__RoadSegment __declspec(deprecated)
#endif

namespace etsi_its_mapem_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RoadSegment_
{
  using Type = RoadSegment_<ContainerAllocator>;

  explicit RoadSegment_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : name(_init),
    id(_init),
    revision(_init),
    ref_point(_init),
    lane_width(_init),
    speed_limits(_init),
    road_lane_set(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name_is_present = false;
      this->lane_width_is_present = false;
      this->speed_limits_is_present = false;
    }
  }

  explicit RoadSegment_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : name(_alloc, _init),
    id(_alloc, _init),
    revision(_alloc, _init),
    ref_point(_alloc, _init),
    lane_width(_alloc, _init),
    speed_limits(_alloc, _init),
    road_lane_set(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name_is_present = false;
      this->lane_width_is_present = false;
      this->speed_limits_is_present = false;
    }
  }

  // field types and members
  using _name_type =
    etsi_its_mapem_ts_msgs::msg::DescriptiveName_<ContainerAllocator>;
  _name_type name;
  using _name_is_present_type =
    bool;
  _name_is_present_type name_is_present;
  using _id_type =
    etsi_its_mapem_ts_msgs::msg::RoadSegmentReferenceID_<ContainerAllocator>;
  _id_type id;
  using _revision_type =
    etsi_its_mapem_ts_msgs::msg::MsgCount_<ContainerAllocator>;
  _revision_type revision;
  using _ref_point_type =
    etsi_its_mapem_ts_msgs::msg::Position3D_<ContainerAllocator>;
  _ref_point_type ref_point;
  using _lane_width_type =
    etsi_its_mapem_ts_msgs::msg::LaneWidth_<ContainerAllocator>;
  _lane_width_type lane_width;
  using _lane_width_is_present_type =
    bool;
  _lane_width_is_present_type lane_width_is_present;
  using _speed_limits_type =
    etsi_its_mapem_ts_msgs::msg::SpeedLimitList_<ContainerAllocator>;
  _speed_limits_type speed_limits;
  using _speed_limits_is_present_type =
    bool;
  _speed_limits_is_present_type speed_limits_is_present;
  using _road_lane_set_type =
    etsi_its_mapem_ts_msgs::msg::RoadLaneSetList_<ContainerAllocator>;
  _road_lane_set_type road_lane_set;

  // setters for named parameter idiom
  Type & set__name(
    const etsi_its_mapem_ts_msgs::msg::DescriptiveName_<ContainerAllocator> & _arg)
  {
    this->name = _arg;
    return *this;
  }
  Type & set__name_is_present(
    const bool & _arg)
  {
    this->name_is_present = _arg;
    return *this;
  }
  Type & set__id(
    const etsi_its_mapem_ts_msgs::msg::RoadSegmentReferenceID_<ContainerAllocator> & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__revision(
    const etsi_its_mapem_ts_msgs::msg::MsgCount_<ContainerAllocator> & _arg)
  {
    this->revision = _arg;
    return *this;
  }
  Type & set__ref_point(
    const etsi_its_mapem_ts_msgs::msg::Position3D_<ContainerAllocator> & _arg)
  {
    this->ref_point = _arg;
    return *this;
  }
  Type & set__lane_width(
    const etsi_its_mapem_ts_msgs::msg::LaneWidth_<ContainerAllocator> & _arg)
  {
    this->lane_width = _arg;
    return *this;
  }
  Type & set__lane_width_is_present(
    const bool & _arg)
  {
    this->lane_width_is_present = _arg;
    return *this;
  }
  Type & set__speed_limits(
    const etsi_its_mapem_ts_msgs::msg::SpeedLimitList_<ContainerAllocator> & _arg)
  {
    this->speed_limits = _arg;
    return *this;
  }
  Type & set__speed_limits_is_present(
    const bool & _arg)
  {
    this->speed_limits_is_present = _arg;
    return *this;
  }
  Type & set__road_lane_set(
    const etsi_its_mapem_ts_msgs::msg::RoadLaneSetList_<ContainerAllocator> & _arg)
  {
    this->road_lane_set = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_mapem_ts_msgs::msg::RoadSegment_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mapem_ts_msgs::msg::RoadSegment_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::RoadSegment_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::RoadSegment_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::RoadSegment_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::RoadSegment_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::RoadSegment_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::RoadSegment_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::RoadSegment_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::RoadSegment_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__RoadSegment
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::RoadSegment_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__RoadSegment
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::RoadSegment_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RoadSegment_ & other) const
  {
    if (this->name != other.name) {
      return false;
    }
    if (this->name_is_present != other.name_is_present) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    if (this->revision != other.revision) {
      return false;
    }
    if (this->ref_point != other.ref_point) {
      return false;
    }
    if (this->lane_width != other.lane_width) {
      return false;
    }
    if (this->lane_width_is_present != other.lane_width_is_present) {
      return false;
    }
    if (this->speed_limits != other.speed_limits) {
      return false;
    }
    if (this->speed_limits_is_present != other.speed_limits_is_present) {
      return false;
    }
    if (this->road_lane_set != other.road_lane_set) {
      return false;
    }
    return true;
  }
  bool operator!=(const RoadSegment_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RoadSegment_

// alias to use template instance with default allocator
using RoadSegment =
  etsi_its_mapem_ts_msgs::msg::RoadSegment_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_mapem_ts_msgs

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__ROAD_SEGMENT__STRUCT_HPP_
